<template>
  <q-layout view="lHh Lpr lFf">
    <q-layout-header>
      <q-toolbar flat class="bg-indigo-5 text-white">

        <q-toolbar-title class="title">
          SOMENAME
        </q-toolbar-title>

        <div v-if="isDesktop" style="width:500px" >
          <MyTabs
          :width="500"
          :tabs="tabs"></MyTabs>
        </div>

        <div style="width:50px"></div>

        <q-btn
          flat
          square
          class="action-theme"
          size="lg"
          icon="exit to app"
          @click="logout()"
        >
        </q-btn>
      </q-toolbar>
    </q-layout-header>

    <div v-if="isMobile">
      <q-layout-footer class="bg-indigo-5">
        <MyTabs
          :width="appWidth"
          :tabs="tabs"></MyTabs>
      </q-layout-footer>
    </div>

    <q-page-container>
      <div v-if="isMobile">
        <q-window-resize-observable @resize="onResize" />
        <transition
        appear
        enter-active-class="animated fadeIn"
        leave-active-class="animated fadeOut"
        mode="out-in"
        >
          <keep-alive>
            <router-view></router-view>
          </keep-alive>
        </transition>
      </div>
      <div v-else>
        <q-window-resize-observable @resize="onResize" />
        <transition
        appear
        :enter-active-class="pageRight ? 'animated bounceInRight' : 'animated bounceInLeft'"
        :leave-active-class="pageRight ? 'animated bounceOutLeft' : 'animated bounceOutRight'"
        mode="out-in"
        >
          <keep-alive>
            <router-view></router-view>
          </keep-alive>
        </transition>
      </div>
    </q-page-container>
  </q-layout>
</template>

<script>
import { openURL } from 'quasar'

import MyTabs from 'src/components/mytabs'

export default {
  name: 'AppLayout',
  components: {
    MyTabs
  },
  data () {
    return {
      leftDrawerOpen: this.$q.platform.is.desktop,
      isMobile: true,
      isDesktop: false,
      appWidth: 0,
      tabs: [
        {
          name: 'account',
          icon: 'account circle',
          path: '/app/account'
        },
        {
          name: 'top searches',
          icon: 'whatshot',
          path: '/app/topsearches'
        },
        {
          name: 'jobs',
          icon: 'work',
          path: '/app/jobs'
        },
        {
          name: 'documents',
          icon: 'find in page',
          path: '/app/search'
        },
        {
          name: 'upload',
          icon: 'file upload',
          path: '/app/upload'
        }
      ],
      pageRight: true
    }
  },
  watch: {
    $route: function (newVal, oldVal) {
      console.log(`from ${oldVal.path} to ${newVal.path}`)
      let from = oldVal.path
      let to = newVal.path

      if (this.tabPaths.indexOf(from) < this.tabPaths.indexOf(to)) {
        this.pageRight = true
      } else {
        this.pageRight = false
      }
    }
  },
  created () {
  },
  computed: {
    tabPaths () {
      return this.tabs.map((val) => { return val.path })
    }
  },
  methods: {
    openURL,
    onResize (size) {
      // console.log(size)
      this.appWidth = size.width
      if (size.width < 1200) {
        this.isMobile = true
        this.isDesktop = false
      } else {
        this.isDesktop = true
        this.isMobile = false
      }
    },
    logout () {
      this.$session.set('loggedin', false)
      this.$session.set('username', '')
      this.$session.set('userid', '')
      this.$router.push('/login')
    },
    isPath (path) {
      if (this.$route.path === path) {
        return true
      }
      return false
    },
    openAccount () {
      this.$router.push('/app/account')
    },
    openUpload () {
      this.$router.push('/app/upload')
    },
    openSearch () {
      this.$router.push('/app/search')
    },
    openTopSearches () {
      this.$router.push('/app/topsearches')
    }
  }
}
</script>

<style lang="stylus">
@import '~variables'

.action-theme
  background-color $indigo-5
  color $white

.active-action-theme
  background-color rgba(238, 120, 80, 0.9) // deep-orange-5, 90% opacity
  color $white

.modal-title
  font-family 'Roboto Mono', monospace
  font-weight 800
  text-transform uppercase

.term-chip
  font-family 'Roboto Mono', monospace
  font-weight 600
  background-color $light-blue-5
  color $white

.header
  position fixed
  top 0
  width 100%
  background white
</style>
